<?php

namespace App\domain\travelport;

use App\Models\CalendarPrice;
use Illuminate\Database\Eloquent\Collection;
use Illuminate\Support\Carbon;

class QueryCalendarPrice
{
    public function execute(string $from, string $to): Collection|array
    {
        return CalendarPrice::query()
            ->selectRaw('departure_date, MIN(price) as min_price')
            ->where('from',$from)
            ->where('to',$to)
            ->whereDate('departure_date','>=',Carbon::today())
            ->groupBy('departure_date')
            ->get();
    }
}
