<?php

namespace App\domain\travelport\ticketing;

use App\domain\travelport\Workbench;
use Illuminate\Support\Facades\Storage;

class AddFormOfPaymentAction extends Workbench
{
    protected string $ticketWorkbenchAuthorityValue;

    public function execute(string $ticketWorkbenchAuthorityValue)
    {
        $this->ticketWorkbenchAuthorityValue = $ticketWorkbenchAuthorityValue;
        $response = $this->travelportPost();
        Storage::put('travelport/api/8_add_FOP_post_commit_reservation_cash_response.json',json_encode($response, JSON_PRETTY_PRINT));
        return $response;
    }

    protected function buildApiUrl(): string
    {
        return "https://{$this->baseURL}/{$this->apiVersion}/air/payment/reservationworkbench/{$this->ticketWorkbenchAuthorityValue}/formofpayment";
    }

    protected function createPayload(): array
    {
        $payload =[
            "FormOfPaymentCash" => [
                "id" => "formOfPayment_10",
                "FormOfPaymentRef" => "formOfPayment_10",
                "Identifier" => [
                    "authority" => "Travelport",
                    "value" => $this->ticketWorkbenchAuthorityValue
                ]
            ]
        ];
        Storage::put('travelport/api/8_add_FOP_post_commit_reservation_cash_request.json', json_encode($payload, JSON_PRETTY_PRINT));
        return $payload;
    }
}
